diff --git a/contrib/ncurses/misc/ncurses-config.in b/contrib/ncurses/misc/ncurses-config.in
index eae39a516ff3..c9f1cf809843 100644
--- a/contrib/ncurses/misc/ncurses-config.in
+++ b/contrib/ncurses/misc/ncurses-config.in
@@ -1,7 +1,7 @@
 #!@SHELL@
-# $Id: ncurses-config.in,v 1.46 2021/01/23 23:47:46 tom Exp $
+# $Id: ncurses-config.in,v 1.52 2022/07/26 21:36:28 tom Exp $
 ##############################################################################
-# Copyright 2018-2020,2021 Thomas E. Dickey                                  #
+# Copyright 2018-2021,2022 Thomas E. Dickey                                  #
 # Copyright 2006-2015,2017 Free Software Foundation, Inc.                    #
 #                                                                            #
 # Permission is hereby granted, free of charge, to any person obtaining a    #
@@ -98,10 +98,10 @@ fi
 # are standard library directories (i.e., the linker is supposed to search
 # those directories).
 #
-# There is no portable way to find the list of standard library directories. 
+# There is no portable way to find the list of standard library directories.
 # Require a POSIX shell anyway, to keep this simple.
 lib_flags=
-for opt in -L$libdir @LDFLAGS@ @EXTRA_PKG_LDFLAGS@ $LIBS
+for opt in -L$libdir @EXTRA_PKG_LDFLAGS@ $LIBS
 do
 	case $opt in
 	-specs*) # ignore linker specs-files which were used to build library
@@ -110,8 +110,14 @@ do
 	-Wl,-z,*) # ignore flags used to manipulate shared image
 		continue
 		;;
+	-Wl,--dynamic-linker*) # ignore ELF interpreter
+		continue
+		;;
+	-Wl,--as-needed|-Wl,--build-id=*|-Wl,-dT,*|-Wl,-T,*)
+		continue
+		;;
 	-L*)
-		lib_check=${opt##-L} 
+		lib_check=`echo "x$opt" | sed -e 's/^.-L//'`
 		[ -d "$lib_check" ] || continue
 		case "$lib_check" in
 		@LD_SEARCHPATH@) # skip standard libdir
@@ -167,7 +173,7 @@ do
 	lib_flags="$lib_flags $opt"
 done
 
-[ $# = 0 ] && exec @SHELL@ $0 --error
+[ $# = 0 ] && exec @SHELL@ "$0" --error
 
 while [ $# -gt 0 ]; do
 	case "$1" in
@@ -198,7 +204,7 @@ ENDECHO
 			[ -n "$OPTS" ] && OPTS="$OPTS "
 			OPTS="${OPTS}${opt}"
 		done
-		printf "%s\n" "$OPTS"
+		printf '%s\n' "$OPTS"
 		;;
 	--libs-only-L)
 		OPTS=
@@ -211,7 +217,7 @@ ENDECHO
 				;;
 			esac
 		done
-		printf "%s\n" "$OPTS"
+		printf '%s\n' "$OPTS"
 		;;
 	--libs-only-l)
 		OPTS=
@@ -224,7 +230,7 @@ ENDECHO
 				;;
 			esac
 		done
-		printf "%s\n" "$OPTS"
+		printf '%s\n' "$OPTS"
 		;;
 	--libs-only-other)
 		OPTS=
@@ -239,7 +245,7 @@ ENDECHO
 				;;
 			esac
 		done
-		printf "%s\n" "$OPTS"
+		printf '%s\n' "$OPTS"
 		;;
 	# identification
 	--version)
@@ -265,7 +271,7 @@ ENDECHO
 		elif [ "${includedir}" != /usr/include ]; then
 			INCS="${includedir}"
 		fi
-		echo $INCS
+		echo "$INCS"
 		;;
 	--libdir)
 		echo "${libdir}"
@@ -285,7 +291,7 @@ ENDECHO
 	# general info
 	--help)
 		cat <<ENDHELP
-Usage: `basename $0` [options]
+Usage: `basename "$0"` [options]
 
 Options:
   --prefix           echos the package-prefix of ${THIS}
@@ -315,7 +321,7 @@ Options:
 ENDHELP
 		;;
 	--error|*)
-		@SHELL@ $0 --help 1>&2
+		@SHELL@ "$0" --help 1>&2
 		exit 1
 		;;
 	esac
diff --git a/contrib/ncurses/misc/run_tic.in b/contrib/ncurses/misc/run_tic.in
index b335b48e2a0d..bd11c4c80d4c 100644
--- a/contrib/ncurses/misc/run_tic.in
+++ b/contrib/ncurses/misc/run_tic.in
@@ -1,7 +1,7 @@
 #!@SHELL@
-# $Id: run_tic.in,v 1.38 2020/02/15 15:30:53 tom Exp $
+# $Id: run_tic.in,v 1.40 2022/07/16 19:37:03 tom Exp $
 ##############################################################################
-# Copyright 2019,2020 Thomas E. Dickey                                       #
+# Copyright 2019-2020,2022 Thomas E. Dickey                                  #
 # Copyright 2000-2012,2017 Free Software Foundation, Inc.                    #
 #                                                                            #
 # Permission is hereby granted, free of charge, to any person obtaining a    #
@@ -42,21 +42,20 @@ echo "** Building terminfo database, please wait..."
 # The script is designed to be run from the misc/Makefile as
 #	make install.data
 
-: ${suffix:=@EXEEXT@}
-: ${DESTDIR:=@DESTDIR@}
-: ${prefix:=@prefix@}
-: ${exec_prefix:=@exec_prefix@}
-: ${bindir:=@bindir@}
-: ${top_srcdir:=@top_srcdir@}
-: ${srcdir:=@srcdir@}
-: ${datarootdir:=@datarootdir@}
-: ${datadir:=@datadir@}
-: ${TIC_PATH:=@TIC@}
-: ${ticdir:=@TERMINFO@}
-: ${source:=@TERMINFO_SRC@}
-: ${LN_S:="@LN_S@"}
-: ${cross_compiling:=no}
-: ${ext_funcs:=@NCURSES_EXT_FUNCS@}
+: "${suffix:=@EXEEXT@}"
+: "${DESTDIR:=@DESTDIR@}"
+: "${prefix:=@prefix@}"
+: "${exec_prefix:=@exec_prefix@}"
+: "${bindir:=@bindir@}"
+: "${top_srcdir:=@top_srcdir@}"
+: "${srcdir:=@srcdir@}"
+: "${datarootdir:=@datarootdir@}"
+: "${datadir:=@datadir@}"
+: "${TIC_PATH:=@TIC@}"
+: "${ticdir:=@TERMINFO@}"
+: "${source:=@TERMINFO_SRC@}"
+: "${cross_compiling:=no}"
+: "${ext_funcs:=@NCURSES_EXT_FUNCS@}"
 
 test -z "${DESTDIR}" && DESTDIR=
 
@@ -118,7 +117,7 @@ TICDIR=`echo "$TERMINFO" | sed -e 's%/share/\([^/]*\)$%/lib/\1%'`
 PARENT=`echo "$TERMINFO" | sed -e 's%/[^/]*$%%'`
 if test -n "$PARENT"
 then
-	test -d $PARENT || mkdir -p $PARENT
+	mkdir -p "$PARENT"
 fi
 
 # Remove the old terminfo stuff; we don't care if it existed before, and it
@@ -127,7 +126,7 @@ fi
 # the directory is actually a symbolic link.
 if test -d "$TERMINFO"
 then
-	( cd "$TERMINFO" && rm -fr ? 2>/dev/null )
+	( cd "$TERMINFO" && rm -fr ./? 2>/dev/null )
 elif test -f "$TERMINFO.db"
 then
 	( rm -f "$TERMINFO.db" 2>/dev/null )
@@ -183,9 +182,9 @@ if test "$TICDIR" != "$TERMINFO" ; then
 	( rm -f "$TICDIR" 2>/dev/null )
 	if ( cd "$TICDIR" 2>/dev/null )
 	then
-		cd "$TICDIR"
+		cd "$TICDIR" || exit
 		TICDIR=`pwd`
-		if test "$TICDIR "!= "$TERMINFO "; then
+		if test "$TICDIR " != "$TERMINFO "; then
 			# Well, we tried.  Some systems lie to us, so the
 			# installer will have to double-check.
 			echo "Verify if $TICDIR and $TERMINFO are the same."
@@ -193,7 +192,7 @@ if test "$TICDIR" != "$TERMINFO" ; then
 			echo "Otherwise, remove $TICDIR and link it to $TERMINFO."
 		fi
 	else
-		cd ${DESTDIR}$prefix
+		cd ${DESTDIR}$prefix || exit
 		# Construct a symbolic link that only assumes $ticdir has the
 		# same $prefix as the other installed directories.
 		RELATIVE=`echo $ticdir|sed -e 's%^'$prefix'/%%'`
diff --git a/contrib/ncurses/misc/shlib b/contrib/ncurses/misc/shlib
index 8772d4f4a9e0..7b93d170e821 100755
--- a/contrib/ncurses/misc/shlib
+++ b/contrib/ncurses/misc/shlib
@@ -1,6 +1,6 @@
 #!/bin/sh
 ##############################################################################
-# Copyright 2020 Thomas E. Dickey                                            #
+# Copyright 2020,2021 Thomas E. Dickey                                       #
 # Copyright 1998-2005,2007 Free Software Foundation, Inc.                    #
 #                                                                            #
 # Permission is hereby granted, free of charge, to any person obtaining a    #
@@ -30,7 +30,7 @@
 #
 # Author: Thomas E. Dickey <dickey@clark.net> 1996
 #
-# $Id: shlib,v 1.13 2020/02/02 23:34:34 tom Exp $
+# $Id: shlib,v 1.14 2021/09/04 15:55:29 tom Exp $
 # Use this script as a wrapper when running executables linked to shared
 # libraries on systems that use the $LD_LIBRARY_PATH variable and don't embed
 # the soname's path within the linked executable (such as IRIX), e.g,
@@ -81,7 +81,7 @@ q=""
 for p in lib ../lib ../../lib ../../../lib
 do
 	if test -d $p; then
-		q=`cd $p; pwd`
+		q=`cd $p || exit; pwd`
 		break
 	elif test -f configure && test ! -d ../$p ; then
 		break
@@ -102,7 +102,7 @@ if test -n "$q" ; then
 	elif test -n "$LD_LIBRARY_PATH"; then
 		system=unix
 	else
-		for r in $q/*.*
+		for r in "$q"/*.*
 		do
 			if test -f "$r"
 			then
diff --git a/contrib/ncurses/misc/tdlint b/contrib/ncurses/misc/tdlint
index 71b0d89b6d4d..8ff5a40bffee 100755
--- a/contrib/ncurses/misc/tdlint
+++ b/contrib/ncurses/misc/tdlint
@@ -1,6 +1,6 @@
 #!/bin/sh
 ##############################################################################
-# Copyright 2020 Thomas E. Dickey                                            #
+# Copyright 2020,2021 Thomas E. Dickey                                       #
 # Copyright 1998,2000 Free Software Foundation, Inc.                         #
 #                                                                            #
 # Permission is hereby granted, free of charge, to any person obtaining a    #
@@ -30,7 +30,7 @@
 #
 # Author: Thomas E. Dickey <dickey@clark.net> 1996
 #
-# $Id: tdlint,v 1.7 2020/02/02 23:34:34 tom Exp $
+# $Id: tdlint,v 1.8 2021/09/04 15:55:29 tom Exp $
 #
 # Lint-script that allows user's own lint libraries, in addition to the ones
 # installed in the system.
@@ -45,16 +45,16 @@ if test -z "$ARCH" ; then
 	exit 1
 else
 	case $ARCH in
-	AIX)	set - $* -Nn4000
+	AIX)	set - "$@" -Nn4000
 		;;
-	IRIX)	set - $* -n -lc
+	IRIX)	set - "$@" -n -lc
 		;;
-	FreeBSD) set - $* -g -p -u -v -z
+	FreeBSD) set - "$@" -g -p -u -v -z
 		;;
 	SunOS)
 		case `uname -r` in
 		5.*)	ARCH=Solaris
-			set - $* -n -lc
+			set - "$@" -n -lc
 			;;
 		esac
 		;;
@@ -63,7 +63,7 @@ fi
 # LIBDIR=$HOME/lib/$ARCH/lint ;export LIBDIR
 for p in $HOME/lib/$ARCH/lint /usr/lib/lint /usr/lib
 do
-	if [ -d $p ]
+	if [ -d "$p" ]
 	then
 		DIRS="$DIRS $p"
 	fi
@@ -74,15 +74,15 @@ do
 	case $1 in
 	-D*\"*)	;;
 	-L*)
-		DIRS="`echo $1|sed -e 's/^-L//'` $DIRS"
+		DIRS="`echo "$1"|sed -e 's/^-L//'` $DIRS"
 		;;
 	-l*)
-		lib="llib-l`echo $1 | sed -e 's/^-l//'`.ln"
+		lib="llib-l`echo "$1" | sed -e 's/^-l//'`.ln"
 		found=no
 		for p in $DIRS
 		do
-			echo -n testing $p/$lib
-			if [ -f $p/$lib ]
+			printf "testing %s" "$p/$lib"
+			if [ -f "$p/$lib" ]
 			then
 				LIBS="$LIBS $p/$lib"
 				echo " (ok)"
@@ -111,4 +111,4 @@ do
 	shift
 done
 #
-eval lint $OPT $FILES $LIBS
+exec lint $OPT $FILES $LIBS
